using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 2005.
	/// To reproduce this sample, 
	/// -drop an rfid component onto the form.
	/// -add an attached callback that checks if there are outputs, 
	///  and if so sets the 3rd one to true (this turns the reader on)
	/// -drop in an rfid Skin, and set its rfid property to the rfid component (e.g., rfid1)
	/// </summary>
	public class rfidSkinSimple : System.Windows.Forms.Form
	{
		private GroupLab.Phidgets.RFID rfid1;
		private GroupLab.Phidgets.UI.RFIDSkin rfidSkin1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public rfidSkinSimple()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.rfid1 = new GroupLab.Phidgets.RFID();
			this.rfidSkin1 = new GroupLab.Phidgets.UI.RFIDSkin();
			this.SuspendLayout();
			// 
			// rfid1
			// 
			this.rfid1.AutoAttach = true;
			this.rfid1.PhidgetDevice = null;
			this.rfid1.Attach += new System.EventHandler(this.rfid1_Attach);
			// 
			// rfidSkin1
			// 
			this.rfidSkin1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.rfidSkin1.Location = new System.Drawing.Point(0, 0);
			this.rfidSkin1.Name = "rfidSkin1";
			this.rfidSkin1.PhidgetComponent = this.rfid1;
			this.rfidSkin1.RFID = this.rfid1;
			this.rfidSkin1.Size = new System.Drawing.Size(408, 126);
			this.rfidSkin1.TabIndex = 0;
			// 
			// rfidSkinSimple
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(408, 126);
			this.Controls.Add(this.rfidSkin1);
			this.Name = "rfidSkinSimple";
			this.Text = "rfidSkinSimple";
			this.ResumeLayout(false);

		}
		#endregion

		private void rfid1_Attach(object sender, System.EventArgs e)
		{
			if (rfid1.Outputs.Count >= 3) rfid1.Outputs[3].State = true;
		}
	}
}
