using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 4 2005
	/// The rfidTester provides a GUI that shows and exercises all properties, methods
	/// and events of the basic rfid component.
	/// </summary>
	public class rfidTester : System.Windows.Forms.Form
	{
		#region Declarations
		private GroupLab.Phidgets.RFID rfid1;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label labelVersion;
		private System.Windows.Forms.Label labelSerialNumber;
		private System.Windows.Forms.Label labelAttached;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label labelOutputCount;
		private System.Windows.Forms.CheckedListBox checkedListBox1;
		private System.Windows.Forms.Label labelTag;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label labelTimesSeen;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;

		private System.ComponentModel.Container components = null;
		#endregion

		public rfidTester()
		{
			InitializeComponent();

			// Display explanatory note and set a reasonable default
			label3.Text = "Version 2 of the RFID Hardware has various extra abilities accessed by ";
			label3.Text += "manipulating the output state. The most important is Outputs[3].State ";
			label3.Text += "which turns the reader on and off. ";
			label3.Text += "If you don't see any checkboxes, you are using Version 1. ";
			labelAttached.Text = false.ToString ();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.rfid1 = new GroupLab.Phidgets.RFID();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.checkedListBox1 = new System.Windows.Forms.CheckedListBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.labelOutputCount = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.labelVersion = new System.Windows.Forms.Label();
			this.labelSerialNumber = new System.Windows.Forms.Label();
			this.labelAttached = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.labelTag = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.labelTimesSeen = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// rfid1
			// 
			this.rfid1.AutoAttach = true;
			this.rfid1.PhidgetDevice = null;
			this.rfid1.Attach += new System.EventHandler(this.rfid1_Attach);
			this.rfid1.Tag += new GroupLab.Phidgets.RFIDTagEventHandler(this.rfid1_Tag);
			this.rfid1.Detach += new System.EventHandler(this.rfid1_Detach);
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.checkedListBox1);
			this.groupBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox1.Location = new System.Drawing.Point(280, 80);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(248, 112);
			this.groupBox1.TabIndex = 11;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "RFID Output Values";
			// 
			// checkedListBox1
			// 
			this.checkedListBox1.BackColor = System.Drawing.SystemColors.Control;
			this.checkedListBox1.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.checkedListBox1.CheckOnClick = true;
			this.checkedListBox1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.checkedListBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.checkedListBox1.Location = new System.Drawing.Point(3, 24);
			this.checkedListBox1.Name = "checkedListBox1";
			this.checkedListBox1.Size = new System.Drawing.Size(242, 85);
			this.checkedListBox1.TabIndex = 19;
			this.checkedListBox1.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.checkedListBox1_ItemCheck);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.labelOutputCount);
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.labelVersion);
			this.groupBox2.Controls.Add(this.labelSerialNumber);
			this.groupBox2.Controls.Add(this.labelAttached);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(16, 80);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(248, 112);
			this.groupBox2.TabIndex = 12;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "RFID Hardware";
			// 
			// labelOutputCount
			// 
			this.labelOutputCount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelOutputCount.Location = new System.Drawing.Point(112, 72);
			this.labelOutputCount.Name = "labelOutputCount";
			this.labelOutputCount.Size = new System.Drawing.Size(96, 16);
			this.labelOutputCount.TabIndex = 16;
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(8, 72);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(96, 24);
			this.label7.TabIndex = 15;
			this.label7.Text = "Outputs count:";
			this.label7.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelVersion
			// 
			this.labelVersion.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelVersion.Location = new System.Drawing.Point(112, 56);
			this.labelVersion.Name = "labelVersion";
			this.labelVersion.Size = new System.Drawing.Size(96, 16);
			this.labelVersion.TabIndex = 14;
			// 
			// labelSerialNumber
			// 
			this.labelSerialNumber.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelSerialNumber.Location = new System.Drawing.Point(112, 40);
			this.labelSerialNumber.Name = "labelSerialNumber";
			this.labelSerialNumber.Size = new System.Drawing.Size(96, 16);
			this.labelSerialNumber.TabIndex = 13;
			// 
			// labelAttached
			// 
			this.labelAttached.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelAttached.Location = new System.Drawing.Point(112, 24);
			this.labelAttached.Name = "labelAttached";
			this.labelAttached.Size = new System.Drawing.Size(96, 16);
			this.labelAttached.TabIndex = 12;
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 56);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 24);
			this.label4.TabIndex = 11;
			this.label4.Text = "Version:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 24);
			this.label2.TabIndex = 10;
			this.label2.Text = "Serial number:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(32, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 9;
			this.label1.Text = "Attached: ";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelTag
			// 
			this.labelTag.Font = new System.Drawing.Font("Microsoft Sans Serif", 24F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelTag.Location = new System.Drawing.Point(288, 200);
			this.labelTag.Name = "labelTag";
			this.labelTag.Size = new System.Drawing.Size(232, 48);
			this.labelTag.TabIndex = 13;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(16, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(504, 64);
			this.label3.TabIndex = 14;
			this.label3.Text = "label3";
			// 
			// labelTimesSeen
			// 
			this.labelTimesSeen.Font = new System.Drawing.Font("Microsoft Sans Serif", 24F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelTimesSeen.Location = new System.Drawing.Point(288, 248);
			this.labelTimesSeen.Name = "labelTimesSeen";
			this.labelTimesSeen.Size = new System.Drawing.Size(232, 48);
			this.labelTimesSeen.TabIndex = 15;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 24F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(32, 200);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(232, 48);
			this.label5.TabIndex = 16;
			this.label5.Text = "Tag Value";
			this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label6
			// 
			this.label6.Font = new System.Drawing.Font("Microsoft Sans Serif", 24F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label6.Location = new System.Drawing.Point(32, 248);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(232, 48);
			this.label6.TabIndex = 17;
			this.label6.Text = "Times Seen";
			this.label6.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// rfidTester
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 302);
			this.Controls.Add(this.label6);
			this.Controls.Add(this.label5);
			this.Controls.Add(this.labelTimesSeen);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.labelTag);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Name = "rfidTester";
			this.Text = "rfidTester";
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		// When an rfid reader is detected,
		// - display all information about it
		// - if the board has any outputs (available only in version 2 of the hardware),
		//   display the outputs and set its state to reasonable values.
		//   The most important thing is to turn the reader on through output state 3.
		private void rfid1_Attach(object sender, System.EventArgs e)
		{
			// Status information: Display information about the attached rfid hardware device.
			labelAttached.Text = true.ToString (); 
			labelVersion.Text = rfid1.PhidgetDevice.Version.ToString ();
			labelSerialNumber.Text = rfid1.PhidgetDevice.SerialNumber.ToString ();
			labelOutputCount.Text = rfid1.Outputs.Count.ToString ();

			// Display the output properties of the rfid ; we assume there will be at most 4
			if (rfid1.Outputs.Count != 0) 
			{
				for (int i=0; i < rfid1.Outputs.Count; i++) 
				{
					bool state ;
					string annotation;
					// Important logic: for newer RFID readers with outputs, 
					// the state of outputs 3 must be set to true to turn on the
					// reader. Otherwise just annotate their functions and set them
					// to false.
					state = false;
					switch (i) 
					{
						case 0:
							annotation = " (5 volt output)";
							break;
						case 1:
							annotation = " (external LED)";
							break;
						case 2:
							annotation = " (on board LED )";
							break;
						case 3:
							annotation = " (activate reader)";
							state = true;
							break;
						default:
							annotation = " (unknown)";
							break;
					}
					checkedListBox1.Items.Add (i.ToString () + annotation, state);
					rfid1.Outputs[i].State = state ;	
				}
			}
		}

		// When the rfid reader is detached, clear the display
		private void rfid1_Detach(object sender, System.EventArgs e)
		{
			for (int i=0; i < checkedListBox1.Items.Count; i++) 
			{
				checkedListBox1.Items.Clear ();
			}
			labelAttached.Text = false.ToString (); 
			labelVersion.Text = ""; 
			labelSerialNumber.Text = "";
			labelOutputCount.Text = "";		
			tagLastRecorded = "";
			tagTimesSeen = 0;
			labelTag.Text = "";
			labelTimesSeen.Text = "";
		}

		// On a tag event, display the tag value. Because the same tag can be seen
		// repeatedly, keep track of how many times it was seen and display that as
		// a separate number. When a new tag is seen, start again at zero.
		string tagLastRecorded = "";
		int tagTimesSeen = 0;
		private void rfid1_Tag(object sender, GroupLab.Phidgets.RFIDTagEventArgs e)
		{
			if (e.Tag.ToString() != tagLastRecorded) {
				tagTimesSeen = 0;
				tagLastRecorded = e.Tag.ToString ();
			}
			tagTimesSeen ++;
			labelTag.Text = e.Tag.ToString ();
			labelTimesSeen.Text = tagTimesSeen.ToString ();
		}

		// Let the user set the state of a particular Output via a checkbox selection
		private void checkedListBox1_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
		{
			rfid1.Outputs[e.Index].State = (e.NewValue == 0) ? false : true ; 
		}
	}
}
