using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Summary description for servoSimple.
	/// </summary>
	public class servoSimple : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label labelDescription;
		private GroupLab.Phidgets.Servo servo1;
		private System.Windows.Forms.TrackBar trackBar1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label labelPosition;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public servoSimple()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			labelDescription.Text = "This simple program controls the first motor on a servo phidget.";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.labelDescription = new System.Windows.Forms.Label();
			this.servo1 = new GroupLab.Phidgets.Servo();
			this.trackBar1 = new System.Windows.Forms.TrackBar();
			this.label1 = new System.Windows.Forms.Label();
			this.labelPosition = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).BeginInit();
			this.SuspendLayout();
			// 
			// labelDescription
			// 
			this.labelDescription.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelDescription.Location = new System.Drawing.Point(8, 16);
			this.labelDescription.Name = "labelDescription";
			this.labelDescription.Size = new System.Drawing.Size(384, 16);
			this.labelDescription.TabIndex = 0;
			// 
			// servo1
			// 
			this.servo1.AutoAttach = true;
			this.servo1.PhidgetDevice = null;
			this.servo1.Attach += new System.EventHandler(this.servo1_Attach);
			this.servo1.PositionChange += new GroupLab.Phidgets.ServoEventHandler(this.servo1_PositionChange);
			this.servo1.Detach += new System.EventHandler(this.servo1_Detach);
			// 
			// trackBar1
			// 
			this.trackBar1.Enabled = false;
			this.trackBar1.Location = new System.Drawing.Point(8, 40);
			this.trackBar1.Maximum = 180;
			this.trackBar1.Name = "trackBar1";
			this.trackBar1.Size = new System.Drawing.Size(384, 45);
			this.trackBar1.TabIndex = 1;
			this.trackBar1.TickFrequency = 10;
			this.trackBar1.Scroll += new System.EventHandler(this.trackBar1_Scroll);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.label1.Location = new System.Drawing.Point(8, 96);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 32);
			this.label1.TabIndex = 2;
			this.label1.Text = "Position:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.BottomRight;
			// 
			// labelPosition
			// 
			this.labelPosition.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelPosition.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.labelPosition.Location = new System.Drawing.Point(112, 96);
			this.labelPosition.Name = "labelPosition";
			this.labelPosition.Size = new System.Drawing.Size(272, 32);
			this.labelPosition.TabIndex = 3;
			this.labelPosition.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// servoSimple
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 134);
			this.Controls.Add(this.labelPosition);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.trackBar1);
			this.Controls.Add(this.labelDescription);
			this.Name = "servoSimple";
			this.Text = "servoSimple - Detached";
			((System.ComponentModel.ISupportInitialize)(this.trackBar1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void servo1_Attach(object sender, System.EventArgs e)
		{
			this.Text = "servoSimple - Attached";
			trackBar1.Enabled = true;
		}

		private void servo1_Detach(object sender, System.EventArgs e)
		{
			this.Text = "servoSimple - Detached";
			trackBar1.Enabled = false;		
			labelPosition.Text = "";
		}

		private void servo1_PositionChange(object sender, GroupLab.Phidgets.ServoEventArgs e)
		{
			labelPosition.Text = e.Position.ToString ();
		}

		private void trackBar1_Scroll(object sender, System.EventArgs e)
		{
			servo1.Motors[0].Position = (float) trackBar1.Value;
		}
	}
}
