using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 4 2005
	/// The servoTester provides a GUI that shows and exercises all properties, methods
	/// and events of the basic servo component.
	/// Its complexity is in the GUI,  because this program dynamically 
	/// creates a trackbar and a label for each motor that the attached servo hardware can control.
	/// Thus it is general purpose, and will work for various versions of the servo board.
	/// </summary>
	public class servoTester : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label labelMotorsCount;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label labelVersion;
		private System.Windows.Forms.Label labelSerialNumber;
		private System.Windows.Forms.Label labelAttached;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private GroupLab.Phidgets.Servo servo1;
		private System.Windows.Forms.Panel panelMotors;
	
		// Use these to hold the trackbars and labels created for each motor
		private TrackBar[] motorTrackBars;
		private Label[] motorLabels;
		private EventHandler motorTrackBar_ScrollHandler;
		
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public servoTester()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			this.motorTrackBar_ScrollHandler = new EventHandler(motorTrackBar_Scroll);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.labelMotorsCount = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.labelVersion = new System.Windows.Forms.Label();
			this.labelSerialNumber = new System.Windows.Forms.Label();
			this.labelAttached = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.servo1 = new GroupLab.Phidgets.Servo();
			this.panelMotors = new System.Windows.Forms.Panel();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.labelMotorsCount);
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.labelVersion);
			this.groupBox2.Controls.Add(this.labelSerialNumber);
			this.groupBox2.Controls.Add(this.labelAttached);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(8, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(248, 112);
			this.groupBox2.TabIndex = 13;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Servo Hardware";
			// 
			// labelMotorsCount
			// 
			this.labelMotorsCount.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelMotorsCount.Location = new System.Drawing.Point(112, 72);
			this.labelMotorsCount.Name = "labelMotorsCount";
			this.labelMotorsCount.Size = new System.Drawing.Size(96, 16);
			this.labelMotorsCount.TabIndex = 16;
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(8, 72);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(96, 24);
			this.label7.TabIndex = 15;
			this.label7.Text = "Motors count:";
			this.label7.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelVersion
			// 
			this.labelVersion.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelVersion.Location = new System.Drawing.Point(112, 56);
			this.labelVersion.Name = "labelVersion";
			this.labelVersion.Size = new System.Drawing.Size(96, 16);
			this.labelVersion.TabIndex = 14;
			// 
			// labelSerialNumber
			// 
			this.labelSerialNumber.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelSerialNumber.Location = new System.Drawing.Point(112, 40);
			this.labelSerialNumber.Name = "labelSerialNumber";
			this.labelSerialNumber.Size = new System.Drawing.Size(96, 16);
			this.labelSerialNumber.TabIndex = 13;
			// 
			// labelAttached
			// 
			this.labelAttached.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelAttached.Location = new System.Drawing.Point(112, 24);
			this.labelAttached.Name = "labelAttached";
			this.labelAttached.Size = new System.Drawing.Size(96, 16);
			this.labelAttached.TabIndex = 12;
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 56);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 24);
			this.label4.TabIndex = 11;
			this.label4.Text = "Version:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 24);
			this.label2.TabIndex = 10;
			this.label2.Text = "Serial number:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(32, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 9;
			this.label1.Text = "Attached: ";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// servo1
			// 
			this.servo1.AutoAttach = true;
			this.servo1.PhidgetDevice = null;
			this.servo1.Attach += new System.EventHandler(this.servo1_Attach);
			this.servo1.PositionChange += new GroupLab.Phidgets.ServoEventHandler(this.servo1_PositionChange);
			this.servo1.Detach += new System.EventHandler(this.servo1_Detach);
			// 
			// panelMotors
			// 
			this.panelMotors.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.panelMotors.Location = new System.Drawing.Point(0, 134);
			this.panelMotors.Name = "panelMotors";
			this.panelMotors.Size = new System.Drawing.Size(480, 248);
			this.panelMotors.TabIndex = 14;
			// 
			// servoTester
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(480, 382);
			this.Controls.Add(this.panelMotors);
			this.Controls.Add(this.groupBox2);
			this.Name = "servoTester";
			this.Text = "servoTester";
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		// When a servo is detected,
		// - display all information about it, including the number of motors
		// - display the motors and their positions.
		// Note: the complexity is in the GUI, not in the servos!

		private void servo1_Attach(object sender, System.EventArgs e)
		{
			int motorLabelWidth=56;

			// Status information: Display information about the attached rfid hardware device.
			labelAttached.Text = true.ToString (); 
			labelVersion.Text = servo1.PhidgetDevice.Version.ToString ();
			labelSerialNumber.Text = servo1.PhidgetDevice.SerialNumber.ToString ();
			labelMotorsCount.Text = servo1.Motors.Count.ToString ();	
	
			// Now create a track bar for each motor. This is complex, but only
			// because we are dynamically creating a GUI
			this.panelMotors.SuspendLayout();
			this.panelMotors.Controls.Clear();

			//create a motorTrackBars array and a trackbar, one for each motor
			this.motorTrackBars = new TrackBar[this.servo1.Motors.Count];
			for(int i=0; i < this.motorTrackBars.Length; i++)
			{
				this.motorTrackBars[i] = createTrackbar (i, motorLabelWidth);
			}

			//create a motorLabels array and a label, one for each motor
			this.motorLabels = new Label[this.servo1.Motors.Count];
			for(int i=0; i < this.motorLabels.Length; i++)
			{
				this.motorLabels[i] = createLabel (i, motorLabelWidth); 
			}

			// Add the trackbar and label controls to the Panel
			this.panelMotors.Controls.AddRange(this.motorTrackBars);
			this.panelMotors.Controls.AddRange(this.motorLabels);
			this.panelMotors.ResumeLayout(true);
		}

		// Create, initialize and position a new Trackbar  
		private TrackBar createTrackbar (int index, int motorLabelWidth) 
		{
			TrackBar tbar=new TrackBar();
			tbar.Name= "motorTrackBar" + index.ToString();
			tbar.TabIndex= index+1;
			tbar.Minimum=0;
			tbar.Maximum=180;
			tbar.TickFrequency=10;
			tbar.Value=(int)this.servo1.Motors[index].Position;
			tbar.Scroll += this.motorTrackBar_ScrollHandler;
			tbar.Tag = index;		// So we can find out which trackbar generated the event
				
			//positioning
			tbar.Top = index * tbar.Height;
			tbar.Width= this.panelMotors.Width - motorLabelWidth;
			tbar.Anchor = AnchorStyles.Top | AnchorStyles.Left | AnchorStyles.Right; 
			return tbar;
		}

		// Create, initialize and position a new label  
		private Label createLabel (int index, int motorLabelWidth) 
		{
			Label lbl = new Label();
			lbl.Name = "motorLabel" + index.ToString ();
			lbl.TabIndex = 0;
			lbl.Text = "Position\n" + this.servo1.Motors[index].Position.ToString();
			lbl.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
				
			//positioning
			lbl.Top = index * this.motorTrackBars[index].Height;
			lbl.Left = this.motorTrackBars[index].Width;
			lbl.Height = this.motorTrackBars[index].Height;
			lbl.Width = motorLabelWidth;
			lbl.Anchor = AnchorStyles.Top | AnchorStyles.Right;
			return lbl;
		}

		private void servo1_Detach(object sender, System.EventArgs e)
		{
			labelAttached.Text = false.ToString (); 
			labelVersion.Text = ""; 
			labelSerialNumber.Text = "";
			labelMotorsCount.Text = "";				

			// Remove all the trackbars and labels
			this.panelMotors.SuspendLayout();
			this.panelMotors.Controls.Clear();
			this.panelMotors.ResumeLayout();

			if(null != this.motorTrackBars)
			{
				foreach( TrackBar t in this.motorTrackBars ) 
					t.Dispose ();
				this.motorTrackBars  = null;
			}
			if(null != this.motorLabels)
			{
				foreach( Label l in this.motorLabels)
					l.Dispose ();
				this.motorLabels = null;
			}
		}

		private void servo1_PositionChange(object sender, GroupLab.Phidgets.ServoEventArgs e)
		{
			motorLabels[e.Index].Text="Position\n" + e.Position.ToString();
		}

		private void motorTrackBar_Scroll(object sender, System.EventArgs e)
		{
			// the trackbar tag contains the index of the motor it represents
			TrackBar tbar = (TrackBar) sender;
			this.servo1.Motors[(int) tbar.Tag].Position = tbar.Value;
		}
	}
}
