using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 4 2005
	/// textLCDSimple provides a very simple GUI that illustrates the 
	/// basic use of the textLCD component. 
	/// -the attached/detached state is shown in the title bar
	/// -the backlight is turned on
	/// -whatever a person types into a text box (whose size is set to be
	///  (equivalent to the total characters in the textLCD) is displayed
	/// </summary>
	public class textLCDSimple : System.Windows.Forms.Form
	{
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label3;
		private GroupLab.Phidgets.TextLCD textLCD1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public textLCDSimple()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.textLCD1 = new GroupLab.Phidgets.TextLCD();
			this.SuspendLayout();
			// 
			// textBox1
			// 
			this.textBox1.Enabled = false;
			this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(8, 48);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(520, 31);
			this.textBox1.TabIndex = 18;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(8, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(520, 24);
			this.label3.TabIndex = 19;
			this.label3.Text = "Text typed in here will appear on the LCD display";
			// 
			// textLCD1
			// 
			this.textLCD1.AutoAttach = true;
			this.textLCD1.Display = null;
			this.textLCD1.PhidgetDevice = null;
			this.textLCD1.Attach += new System.EventHandler(this.textLCD1_Attach);
			this.textLCD1.Detach += new System.EventHandler(this.textLCD1_Detach);
			// 
			// textLCDSimple
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 86);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label3);
			this.Name = "textLCDSimple";
			this.Text = "textLCDSimple - Detached";
			this.ResumeLayout(false);

		}
		#endregion

		private void textLCD1_Attach(object sender, System.EventArgs e)
		{	
			this.Text = "textLCDSimple - Attached";
			textBox1.Enabled = true;
			textBox1.MaxLength = textLCD1.NumRows * textLCD1.NumColumns;
			textBox1.Text = "Type text here.";
			textLCD1.Backlight = true;
			textLCD1.CursorBlink = false;
			textLCD1.Display = textBox1.Text;
		}

		private void textLCD1_Detach(object sender, System.EventArgs e)
		{
			this.Text = "textLCDSimple - Detached";
			textBox1.Text = "";
			textBox1.Enabled = false;
		}

		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			textLCD1.Display = textBox1.Text;
		}
	}
}
