using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 4 2005
	/// The textLCDTester provides a GUI that shows and exercises all properties, methods
	/// and events of the basic textLCD component.	
	/// One thing you will notice is that its not worth turning the cursor blink on,
	/// and that the backlight is critical if you want to see what is happening.
	/// You will also see that if you want to do line feeds and word boundaries, 
	/// you have to do it yourself based on calculations of the rows/columns properties 
	/// (I haven't done it in here)
	/// </summary>
	public class textLCDTester : System.Windows.Forms.Form
	{
		#region Declarations
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label labelVersion;
		private System.Windows.Forms.Label labelSerialNumber;
		private System.Windows.Forms.Label labelAttached;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private GroupLab.Phidgets.TextLCD textLCD1;
		private System.Windows.Forms.Label labelRows;
		private System.Windows.Forms.Label labelColumns;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.CheckBox checkBoxCursorBlink;
		private System.Windows.Forms.CheckBox checkBoxBacklight;
		private System.Windows.Forms.TextBox textBox1;
		private System.Windows.Forms.Label label3;
		#endregion
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public textLCDTester()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.labelRows = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.labelVersion = new System.Windows.Forms.Label();
			this.labelSerialNumber = new System.Windows.Forms.Label();
			this.labelAttached = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.textLCD1 = new GroupLab.Phidgets.TextLCD();
			this.labelColumns = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.checkBoxCursorBlink = new System.Windows.Forms.CheckBox();
			this.checkBoxBacklight = new System.Windows.Forms.CheckBox();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.groupBox2.SuspendLayout();
			this.SuspendLayout();
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.labelColumns);
			this.groupBox2.Controls.Add(this.label5);
			this.groupBox2.Controls.Add(this.labelRows);
			this.groupBox2.Controls.Add(this.label7);
			this.groupBox2.Controls.Add(this.labelVersion);
			this.groupBox2.Controls.Add(this.labelSerialNumber);
			this.groupBox2.Controls.Add(this.labelAttached);
			this.groupBox2.Controls.Add(this.label4);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.groupBox2.Location = new System.Drawing.Point(8, 8);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(216, 112);
			this.groupBox2.TabIndex = 13;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "TextLCD Hardware";
			// 
			// labelRows
			// 
			this.labelRows.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelRows.Location = new System.Drawing.Point(112, 72);
			this.labelRows.Name = "labelRows";
			this.labelRows.Size = new System.Drawing.Size(96, 16);
			this.labelRows.TabIndex = 16;
			// 
			// label7
			// 
			this.label7.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label7.Location = new System.Drawing.Point(40, 72);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(64, 24);
			this.label7.TabIndex = 15;
			this.label7.Text = "Rows:";
			this.label7.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labelVersion
			// 
			this.labelVersion.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelVersion.Location = new System.Drawing.Point(112, 56);
			this.labelVersion.Name = "labelVersion";
			this.labelVersion.Size = new System.Drawing.Size(96, 16);
			this.labelVersion.TabIndex = 14;
			// 
			// labelSerialNumber
			// 
			this.labelSerialNumber.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelSerialNumber.Location = new System.Drawing.Point(112, 40);
			this.labelSerialNumber.Name = "labelSerialNumber";
			this.labelSerialNumber.Size = new System.Drawing.Size(96, 16);
			this.labelSerialNumber.TabIndex = 13;
			// 
			// labelAttached
			// 
			this.labelAttached.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelAttached.Location = new System.Drawing.Point(112, 24);
			this.labelAttached.Name = "labelAttached";
			this.labelAttached.Size = new System.Drawing.Size(96, 16);
			this.labelAttached.TabIndex = 12;
			// 
			// label4
			// 
			this.label4.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label4.Location = new System.Drawing.Point(8, 56);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(96, 24);
			this.label4.TabIndex = 11;
			this.label4.Text = "Version:";
			this.label4.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label2
			// 
			this.label2.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label2.Location = new System.Drawing.Point(8, 40);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(96, 24);
			this.label2.TabIndex = 10;
			this.label2.Text = "Serial number:";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(32, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 24);
			this.label1.TabIndex = 9;
			this.label1.Text = "Attached: ";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// textLCD1
			// 
			this.textLCD1.AutoAttach = true;
			this.textLCD1.Display = null;
			this.textLCD1.PhidgetDevice = null;
			this.textLCD1.Attach += new System.EventHandler(this.textLCD1_Attach);
			this.textLCD1.Detach += new System.EventHandler(this.textLCD1_Detach);
			// 
			// labelColumns
			// 
			this.labelColumns.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelColumns.Location = new System.Drawing.Point(112, 88);
			this.labelColumns.Name = "labelColumns";
			this.labelColumns.Size = new System.Drawing.Size(96, 16);
			this.labelColumns.TabIndex = 18;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.Location = new System.Drawing.Point(32, 88);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(72, 16);
			this.label5.TabIndex = 17;
			this.label5.Text = "Columns:";
			this.label5.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// checkBoxCursorBlink
			// 
			this.checkBoxCursorBlink.Enabled = false;
			this.checkBoxCursorBlink.Location = new System.Drawing.Point(232, 72);
			this.checkBoxCursorBlink.Name = "checkBoxCursorBlink";
			this.checkBoxCursorBlink.Size = new System.Drawing.Size(200, 32);
			this.checkBoxCursorBlink.TabIndex = 14;
			this.checkBoxCursorBlink.Text = "Cursor blink";
			this.checkBoxCursorBlink.CheckedChanged += new System.EventHandler(this.checkBoxCursorBlink_CheckedChanged);
			// 
			// checkBoxBacklight
			// 
			this.checkBoxBacklight.Enabled = false;
			this.checkBoxBacklight.Location = new System.Drawing.Point(232, 96);
			this.checkBoxBacklight.Name = "checkBoxBacklight";
			this.checkBoxBacklight.Size = new System.Drawing.Size(200, 32);
			this.checkBoxBacklight.TabIndex = 15;
			this.checkBoxBacklight.Text = "Backlight";
			this.checkBoxBacklight.CheckedChanged += new System.EventHandler(this.checkBoxBacklight_CheckedChanged);
			// 
			// textBox1
			// 
			this.textBox1.Enabled = false;
			this.textBox1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.textBox1.Location = new System.Drawing.Point(8, 184);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(520, 31);
			this.textBox1.TabIndex = 16;
			this.textBox1.Text = "";
			this.textBox1.TextChanged += new System.EventHandler(this.textBox1_TextChanged);
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(8, 152);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(520, 24);
			this.label3.TabIndex = 17;
			this.label3.Text = "Text typed in here will appear on the LCD display";
			// 
			// textLCDTester
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(544, 230);
			this.Controls.Add(this.textBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.checkBoxBacklight);
			this.Controls.Add(this.checkBoxCursorBlink);
			this.Controls.Add(this.groupBox2);
			this.Name = "textLCDTester";
			this.Text = "textLCDTester";
			this.groupBox2.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion
		// Status information: Display information about the attached textLCD hardware device
		private void textLCD1_Attach(object sender, System.EventArgs e)
		{
			labelAttached.Text = true.ToString (); 
			labelVersion.Text = textLCD1.PhidgetDevice.Version.ToString ();
			labelSerialNumber.Text = textLCD1.PhidgetDevice.SerialNumber.ToString ();
			labelRows.Text = textLCD1.NumRows.ToString ();
			labelColumns.Text = textLCD1.NumColumns.ToString ();
			textBox1.Enabled = true;

			// set some defaults on the textLCD device
			// BUG: the CursorBlink does not go off here!
			textLCD1.Backlight = true ;   //you can't see anything if the backlight is off
			textLCD1.CursorBlink = false; //I don't like the cursor blink, so off by default
			textBox1.Text = "Type in here." ; 
			textBox1.MaxLength = textLCD1.NumRows * textLCD1.NumColumns;
			textLCD1.Display = textBox1.Text; 

			// these checkboxes are used to turn the cursor and backlight on and off
			checkBoxCursorBlink.Enabled = true ;
			checkBoxBacklight.Enabled = true ;
			checkBoxCursorBlink.Checked = textLCD1.CursorBlink ;
			checkBoxBacklight.Checked = textLCD1.Backlight ;
		}

		// Status information: clear the information about the  textLCD hardware device.
		private void textLCD1_Detach(object sender, System.EventArgs e)
		{
			labelAttached.Text = false.ToString (); 
			labelVersion.Text = "";
			labelSerialNumber.Text = "";
			labelRows.Text = "";
			labelColumns.Text = "";		
			checkBoxCursorBlink.Enabled = false ;
			checkBoxBacklight.Enabled = false ;
			textBox1.Text = "";
			textBox1.Enabled = false;
		}

		// Turn the TextLCD's cursorblink on or off
		private void checkBoxCursorBlink_CheckedChanged(object sender, System.EventArgs e)
		{
			textLCD1.CursorBlink = checkBoxCursorBlink.Checked;		
		}

		// Turn the TextLCD's backlight on or off
		private void checkBoxBacklight_CheckedChanged(object sender, System.EventArgs e)
		{
			textLCD1.Backlight = checkBoxBacklight.Checked ;				
		}

		// Display the changed text from the textbox in the textLCD
		private void textBox1_TextChanged(object sender, System.EventArgs e)
		{
			textLCD1.Display = textBox1.Text;
		}
	}
}
