using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace GroupLab.Phidgets.Demos
{
	/// <summary>
	/// Author: Saul Greenberg, Feb 4 2005
	/// weigthSensorSimple provides a very simple GUI that illustrates the 
	/// basic use of the weightSensor component. 
	/// -the attached/detached state is shown in the title bar
	/// -the reported weight is shown in a label
	/// </summary>
	public class weightSensorSimple : System.Windows.Forms.Form
	{
		#region Declarations
		private GroupLab.Phidgets.WeightSensor weightSensor1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label labelWeight;
		#endregion
		private System.Windows.Forms.CheckBox checkBox1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.NumericUpDown numericUpDown1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public weightSensorSimple()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				weightSensor1.Dispose();
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.weightSensor1 = new GroupLab.Phidgets.WeightSensor();
			this.label1 = new System.Windows.Forms.Label();
			this.labelWeight = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.numericUpDown1 = new System.Windows.Forms.NumericUpDown();
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).BeginInit();
			this.SuspendLayout();
			// 
			// weightSensor1
			// 
			this.weightSensor1.AutoAttach = true;
			this.weightSensor1.PhidgetDevice = null;
			this.weightSensor1.Attach += new System.EventHandler(this.weightSensor1_Attach);
			this.weightSensor1.Detach += new System.EventHandler(this.weightSensor1_Detach);
			this.weightSensor1.WeightChange += new GroupLab.Phidgets.WeightChangeEventHandler(this.weightSensor1_WeightChange);
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(8, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(96, 48);
			this.label1.TabIndex = 0;
			this.label1.Text = "Weight:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labelWeight
			// 
			this.labelWeight.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labelWeight.Location = new System.Drawing.Point(112, 16);
			this.labelWeight.Name = "labelWeight";
			this.labelWeight.Size = new System.Drawing.Size(88, 48);
			this.labelWeight.TabIndex = 1;
			this.labelWeight.Text = "---";
			this.labelWeight.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label3
			// 
			this.label3.Font = new System.Drawing.Font("Microsoft Sans Serif", 15.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label3.Location = new System.Drawing.Point(208, 15);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(128, 48);
			this.label3.TabIndex = 2;
			this.label3.Text = "pounds";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(16, 72);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.Size = new System.Drawing.Size(176, 24);
			this.checkBox1.TabIndex = 3;
			this.checkBox1.Text = "Use imperial";
			this.checkBox1.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 112);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(128, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Weightchange trigger";
			// 
			// numericUpDown1
			// 
			this.numericUpDown1.DecimalPlaces = 1;
			this.numericUpDown1.Location = new System.Drawing.Point(144, 112);
			this.numericUpDown1.Name = "numericUpDown1";
			this.numericUpDown1.Size = new System.Drawing.Size(96, 20);
			this.numericUpDown1.TabIndex = 5;
			this.numericUpDown1.ValueChanged += new System.EventHandler(this.numericUpDown1_ValueChanged);
			// 
			// weightSensorSimple
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(344, 158);
			this.Controls.Add(this.numericUpDown1);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.labelWeight);
			this.Controls.Add(this.label1);
			this.Name = "weightSensorSimple";
			this.Text = "weightSensorSimple - Detached";
			((System.ComponentModel.ISupportInitialize)(this.numericUpDown1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		// Display the attached state in the title bar
		private void weightSensor1_Attach(object sender, System.EventArgs e)
		{
			this.Text = "weightSensorSimple - Attached";
			weightSensor1.UseImperial = false;
			weightSensor1.WeightChangeTrigger = 1;
		}
		// Display the detached state in the title bar
		private void weightSensor1_Detach(object sender, System.EventArgs e)
		{
			this.Text = "weightSensorSimple - Detached";
			labelWeight.Text = "---";
		}

		// Display the weight (to one decimal place) as a running average in pounds
		// I could have just displayed the current value in kilograms in a single line, 
		// i.e., as labelWeight.Text = e.Value.toString ()
		// but the running average doesn't bounce around as much.
		int index = 0;
		double [] weights = new double [10] ;
		private void weightSensor1_WeightChange(object sender, GroupLab.Phidgets.WeightChangeEventArgs e)
		{
			double running_average = 0;

			weights[index++] = e.Value;
			if (index == weights.Length) index = 0; // cycle around the array
			for (int i=0; i < weights.Length; i++) running_average = weights[i] + running_average;
			running_average /= (double) weights.Length;
			labelWeight.Text  = running_average.ToString ("0.0"); // only one decimal place
		}

		private void numericUpDown1_ValueChanged(object sender, System.EventArgs e)
		{
			weightSensor1.WeightChangeTrigger = (double)numericUpDown1.Value;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			weightSensor1.UseImperial = checkBox1.Checked;
		}
	}
}
